﻿using FalcoEngine;
using System.Linq;

public class BallScript : MonoBehaviour
{
    private Vector3 startPos;
    public float _velocity = 1.5f;
    public Rigidbody _rigidbody;
    public Text _text;
    public Text bestText;
    public float best;
    private float maxHeight = 0f;

    public GameObject deadZone;

    private bool canJump = true;

    public bool isBuild = false;
    private float time;

    void Start()
    {
        best = PlayerPrefs.GetFloat("Highscore");
        startPos = transform.position;
        this.gameObject.rigidbody.isStatic = true;
    }

    void OnTriggerEnter(Rigidbody obj)
    {
        if (obj.gameObject.tag == "PlatformDeadZone")
        {
            Dead();
        }
    }

    void Update()
    {
        float currentHeight = transform.position.y;

        if (currentHeight > maxHeight)
        {
            maxHeight = currentHeight;
            UpdateScoreText(maxHeight);
        }
        if (maxHeight > best)
        {
            float bestRound = Mathf.RoundToInt(maxHeight);
            best = bestRound;
            PlayerPrefs.SetFloat("Highscore", bestRound);
        }
        bestText.text = "Best: " + best;

        if (Input.GetMouseButtonDown(0))
        {
            this.gameObject.rigidbody.isStatic = false;
            _rigidbody.linearVelocity = Vector2.up * _velocity;
            canJump = false;
        }

        if(deadZone.transform.position.y > transform.position.y)
        {
            Dead();
        }
    }
    void UpdateScoreText(float height)
    {
        _text.text = "" + height.ToString("0");
    }

    void FixedUpdate()
    {
        if (!canJump)
        {
            time++;
            if (time == 60)
            {
                canJump = true;
                time = 0;
            }
        }
    }


    public void Dead()
    {
        _text.text = "0";
        maxHeight = 0f;
        if (isBuild == false)
        {
            this.gameObject.rigidbody.linearVelocity = Vector3.zero;
            transform.position = startPos;
            this.gameObject.rigidbody.isStatic = true;
        }
        else
        {
            SceneManager.LoadScene("Scene1.scene");
        }
    }
}
